/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.sanskritlibrary.sanskritalignment;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.sanskritlibrary.CatalogRecord;
import org.sanskritlibrary.Config;
import org.sanskritlibrary.IOAssistance;
import org.sanskritlibrary.Regex;
import org.sanskritlibrary.catalogs.Catalog;
import org.sanskritlibrary.catalogs.Pages;
import org.sanskritlibrary.servlet.SanskritLibraryServlet;

/**
 *
 * @author ralph
 */
public class ImageAlignment extends SanskritLibraryServlet {
    Regex reBrown = new Regex("", "/([0-9.]+)");
    Regex reUPenn = new Regex("", "_item([0-9]+)");

    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        String datadir = getServletContext().getInitParameter("dataDirectory");
        if (!datadir.endsWith("/")) {
            datadir += "/";
        }
        String configFile = datadir + "config.xml";
        StringBuilder sb = new StringBuilder("<html><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"/></head><body>");        
        try {
            Config config = new Config(configFile);
            Pages pages = new Pages(config.imagesLayout);
            Catalog catalog = new Catalog(config.masterCatalog, pages, "slp");
            ArrayList<CatalogRecord> catalogs = catalog.catalogs;
            for (CatalogRecord cr : catalogs) {
                String text = cr.directoryName;
                if (text.startsWith("Brown")) {
                    reBrown.reset(text);
                    if (reBrown.find()) {
                        text = "Brown"+reBrown.getGroup(1);
                    }
                } else {
                    reUPenn.reset(text);
                    if (reUPenn.find()) {
                        text = "UPenn"+reUPenn.getGroup(1);
                    }
                }
                String type = "";
                if (cr.textTypes.size()>0) {
                    type = cr.textTypes.get(0);
                    if (cr.textTypes.size() > 1) {
                        type += "...";
                    }
                }
                sb.append(String.format("<a href='GetAlignmentData?seqno=%d'>%s %s</a><br/>\n", cr.seqno, text, type));
            }
            sb.append("</body>");
            response.setContentType("text/html");
            response.setCharacterEncoding("UTF-8");
            PrintWriter pw = response.getWriter();
            pw.write(sb.toString());
        } catch (Exception ex) {
            throw new IOException(ex);
        }
    }

    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
