"use strict";
$(function() {
    var canvas, ctx, width, height, leftMargin, rightMargin, values;

    width = 800;
    height = 600;
    leftMargin = 20;
    rightMargin = 20;
    
    canvas = $("#graph");
    canvas.attr("width", "" + width + "px");
    canvas.attr("height", "" + height + "px");
    ctx = canvas[0].getContext('2d');
    
    values = [];
    var i;

    drawGraph(locations, charsPerPage);
    
    drawTable(locations);

    function drawGraph(locations, estimate) {
        var x, y, w, h, numpages, i, yMiddle;

        ctx.beginPath();            // crucial to do this or lines won't be cleared!
        ctx.fillStyle = '#ffffff';
        ctx.fillRect(0, 0, width, height);

        // draw X axis
        
        ctx.lineWidth = 2;
        ctx.fillStyle = '#ff0000';
        yMiddle = height/2;
        ctx.moveTo(leftMargin, yMiddle);
        ctx.lineTo(width - rightMargin, yMiddle);
        ctx.stroke();
        w = 2;
        h = 2;

        // plot points
        numpages = locations.length;
        for (i=0; i < numpages; i++) {
            x = leftMargin + i*2;
            y = yMiddle + locations[i].diff;
            ctx.fillRect(x, y, w, h);
        }
    }
    
    function drawTable(locations) {
        var buffer, len, i, location, table, tr, td, pre, lineActual, lineNextActual, lineEstimated, lineNextEstimated;
        table = $("#table");
        table.attr("border", "1px");
        table.css("border-collapse", "collapse");
        len = locations.length;
        lineActual = 0;
        lineEstimated = 0;
        for (i=0; i < len; i++) {
            location = locations[i];
            if (i !== len-1) {
                lineNextActual = locations[i+1].startRow;
                lineNextEstimated = locations[i+1].estimatedStartLine;
            } else {
                lineNextActual = criticalEdition.length;
                lineNextEstimated = criticalEditionCompressed.length;
            }
            tr = $("<tr>");
            table.append(tr);
            // filename
            td = $("<td>");
            tr.append(td);
            td.attr("valign", "top");
            td.html(location.filename);
            
            // diff
            td = $("<td>");
            tr.append(td);
            td.attr("valign", "top");
            td.html(location.diff);

            // actual start row
            td = $("<td>");
            tr.append(td);
            td.attr("valign", "top");
            td.html(location.startRow);
            
            // SITA page content
            td = $("<td>");
            tr.append(td);
            td.attr("valign", "top");
            pre = $("<pre>");
            td.append(pre);
            pre.html(buildPage(criticalEdition, lineActual, lineNextActual));
            
            // estimated start row;
            td = $("<td>");
            tr.append(td);
            td.attr("valign", "top");
            td.html(location.estimatedStartLine+1);
            
            // Compressed content
            td = $("<td>");
            tr.append(td);
            td.attr("valign", "top");
            pre = $("<pre>");
            td.append(pre);
            pre.html(buildPage(criticalEditionCompressed, lineEstimated, lineNextEstimated));

            lineActual = lineNextActual;
            lineEstimated = lineNextEstimated;
        }
    }
    
    function buildPage(a, start, end) {
        var buffer, i;
        
        buffer = "";
        for (i=start; i<end; i++) {
            buffer += a[i] + "\n";
        }
        
        return buffer;
    }
});

